/*
 * System V and Version 9 use strchr; BSD uses index. The following hack
 * tries to accommodate.  
 */
#include <sys/param.h>
#ifndef CLBYTES
#define index strchr
#define rindex strrchr
#endif

int
unsafe(s)
char *s;
{
	register char c;
	/*
	 * check for characters interpretted by the shell (by which nefarious
	 * users might otherwise break into the system) 
	 */
	for (c = (*s); c != '\0'; c = (*++s)) {
		if (index("\"'`$\n;&|^<>()", c) || (c & 0200))
			return (1);
	}
	return (0);
}

/*
 * EXTRACT SENDER'S ADDRESS OUT OF RFC822 "FROM" LINE The sender is either
 * the next first whitespace delimited token or the first thing enclosed in
 * "<" ">". 
 *
 * adapted from /n/bowell/src/cmd/upas (Dave Presotto) (leading "From: " is
 * already deleted before entry) 
 */
int
getfrom(line, sender)
char *line, *sender;
{
	int strncmp();
	char *lp, *sp;
	int comment = 0;
	int anticomment = 0;

	sp = sender;
	for (lp = line; *lp; lp++) {
		if (comment) {
			if (*lp == ')')
				comment = 0;
			continue;
		}
		if (anticomment) {
			if (*lp == '>')
				break;
		}
		switch (*lp) {
		case '\t':
		case '\n':
			break;
		case ' ':
			if (strncmp(lp, " at ", sizeof(" at ") - 1) == 0) {
				*sp++ = '@';
				lp += sizeof(" at ") - 2;
			}
			break;
		case '<':
			anticomment = 1;
			sp = sender;
			break;
		case '(':
			comment = 1;
			break;
		default:
			*sp++ = *lp;
			break;
		}
	}
	*sp = '\0';
	return 1;
}
